package cn.citycraft.SimpleProtect.listen;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map.Entry;

import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.World;
import org.bukkit.block.Block;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.BlockPlaceEvent;
import org.bukkit.event.block.BlockRedstoneEvent;

import cn.citycraft.SimpleProtect.SimpleProtect;

public class HighRedstone implements Runnable, Listener {

	HashMap<Block, Integer> map = new HashMap<Block, Integer>();
	HashMap<Block, Player> pmap = new HashMap<Block, Player>();
	SimpleProtect plugin;
	ArrayList<Player> tipop = new ArrayList<Player>();

	public HighRedstone(SimpleProtect main) {
		plugin = main;
	}

	@EventHandler
	public void onRedClock(BlockRedstoneEvent event) {
		Block rb = event.getBlock();
		if (rb.getType() == Material.REDSTONE_WIRE)
			put(event.getBlock());
	}

	@EventHandler(ignoreCancelled = true)
	public void RedStonePlace(BlockPlaceEvent event) {
		Block rb = event.getBlock();
		Player rp = event.getPlayer();
		if (rb.getType() == Material.REDSTONE_WIRE)
			pmap.put(rb, rp);
	}

	@Override
	public void run() {
		List<Block> blocks = new ArrayList<Block>();
		for (Entry<Block, Integer> entry : map.entrySet())
			if (entry.getValue() > plugin.config.getLong("HighRedstone.Maxevents"))
				blocks.add(entry.getKey());
		Boolean tip = true;
		for (Block block : blocks) {
			World rw = block.getWorld();
			int rx = block.getX();
			int ry = block.getY();
			int rz = block.getZ();
			Player rp = pmap.get(block);
			if (rp != null)
				if (rp.isOp() || rp.hasPermission("sp.ignore.highredstone")) {
					if (!tipop.contains(rp)) {
						rp.sendMessage(plugin.getfullmsg("HighRedstone.Admin"));
						tipop.add(rp);
					}
					continue;
				}
			if (tip) {
				Bukkit.broadcastMessage(plugin.getfullmsg("HighRedstone.Find").replaceAll("%world%", rw.getName()).replaceAll("%x%", rx + "").replaceAll("%y%", ry + "").replaceAll("%z%", rz + ""));
				if (rp != null) {
					Bukkit.broadcastMessage(plugin.getfullmsg("HighRedstone.Check").replaceAll("%player%", rp.getName()));
					pmap.remove(block);
				}
				tip = !tip;
			}
			block.breakNaturally();
		}
		map.clear();
	}

	private void put(Block block) {
		if (map.containsKey(block)) {
			int i = map.remove(block);
			map.put(block, i + 1);
		} else
			map.put(block, 1);
	}
}
